'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Form = undefined;

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _extends5 = require('babel-runtime/helpers/extends');

var _extends6 = _interopRequireDefault(_extends5);

var _keys = require('babel-runtime/core-js/object/keys');

var _keys2 = _interopRequireDefault(_keys);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _helperFunctions = require('./helperFunctions');

var _recompose = require('recompose');

var _Button = require('./Button');

var _Button2 = _interopRequireDefault(_Button);

var _SelectOne = require('./SelectOne');

var _SelectOne2 = _interopRequireDefault(_SelectOne);

var _SelectMany = require('./SelectMany');

var _SelectMany2 = _interopRequireDefault(_SelectMany);

var _ = require('.');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var sumOf = function sumOf(arrayOfNumbers) {
  return arrayOfNumbers.reduce(function (acc, v) {
    acc = acc + v;
    return acc;
  });
};

var Form = function Form(props) {
  var onMount = props.onMount,
      onUnmount = props.onUnmount,
      _props$baseClassName = props.baseClassName,
      baseClassName = _props$baseClassName === undefined ? 'form' : _props$baseClassName,
      className = props.className,
      style = props.style,
      values = props.values,
      touched = props.touched,
      errors = props.errors,
      children = props.children,
      handleChange = props.handleChange,
      handleSubmit = props.handleSubmit,
      setFieldValue = props.setFieldValue,
      setFieldTouched = props.setFieldTouched,
      isSubmitting = props.isSubmitting;

  //useEffect(() => {
  //  onMount && onMount()
  //  return () => {
  //    onUnmount && onUnmount()
  //  }
  //}, [])

  var renderError = function renderError(type) {
    return errors && errors[type] && touched && touched[type] && _react2.default.createElement(
      'div',
      { className: baseClassName + '__error' },
      errors[type]
    );
  };

  var renderTextareaInputSocket = function renderTextareaInputSocket(_ref) {
    var type = _ref.type,
        label = _ref.label,
        _ref$required = _ref.required,
        required = _ref$required === undefined ? true : _ref$required;
    return _react2.default.createElement(
      'div',
      { className: baseClassName + '__socket ' + baseClassName + '__textarea__socket' },
      values[type] && _react2.default.createElement(
        _react.Fragment,
        null,
        _react2.default.createElement(
          'div',
          { className: baseClassName + '__label ' + baseClassName + '__textarea__label' },
          (0, _helperFunctions.capitalizeEveryWord)(label)
        ),
        _react2.default.createElement('textarea', {
          className: baseClassName + '__input ' + baseClassName + '__textarea__input',
          'data-testid': type.toLowerCase() + '-input',
          id: type,
          required: required,
          value: values[type],
          onChange: function onChange(e) {
            return setFieldValue(type, e.target.value);
          }
        })
      ),
      errors[type] && touched[type] && _react2.default.createElement(
        'div',
        { className: 'input-feedback' },
        errors[type]
      )
    );
  };

  var renderSelectManyWithAdvancedCompositionSocket = function renderSelectManyWithAdvancedCompositionSocket(_ref2) {
    var type = _ref2.type,
        label = _ref2.label,
        options = _ref2.options,
        renderTrigger = _ref2.renderTrigger;

    // options contain UI-friendly labels
    console.log(values[type]);
    var currentOptions = values[type] ? (0, _keys2.default)(values[type]).map(function (compositionID) {
      return console.log(values[type]) || {
        value: compositionID,
        label: options.find(function (option) {
          return option.value === compositionID;
        }) ? options.find(function (option) {
          return option.value === compositionID;
        }).label : 'label not found'
      };
    }) : [];
    //const currentOptionsWithInputRefs = currentOptions
    //  ? currentOptions.map(currentOption => ({
    //      label: currentOption.label,
    //      value: currentOption.value,
    //      ref: useRef(null),
    //    }))
    //  : []
    var renderCurrentOptionInputs = function renderCurrentOptionInputs(_ref3) {
      var option = _ref3.option,
          isSigned = _ref3.isSigned;
      return _react2.default.createElement(
        _react.Fragment,
        null,
        _react2.default.createElement('input', {
          //ref: currentOptionsWithInputRefs.find(
          //  currentOption => option.value === currentOption.value
          //).ref,
          onClick: function onClick(e) {
            e.stopPropagation();
            e.nativeEvent.stopImmediatePropagation();
          },
          className: baseClassName + '__component__input',
          id: option.value,
          type: 'range',
          value: isSigned ? values[type][option.value][0] : values[type][option.value],
          onChange: function onChange(v) {
            setFieldValue(type, (0, _extends6.default)({}, values[type], (0, _defineProperty3.default)({}, option.value, isSigned ? [v.target.value, values[type][option.value][1]] : v.target.value)));
          }
        }),
        isSigned ? _react2.default.createElement(
          _SelectOne2.default,
          {
            onChange: function onChange(option) {
              return console.log(option);
            },
            options: [{
              value: -1,
              label: '<'
            }, {
              value: 0,
              label: '='
            }, {
              value: 1,
              label: '>'
            }]
          },
          [{
            value: -1,
            label: '<'
          }, {
            value: 0,
            label: '='
          }, {
            value: 1,
            label: '>'
          }]
        ) : null,
        _react2.default.createElement('input', {
          //ref: currentOptionsWithInputRefs.find(
          //  currentOption => option.value === currentOption.value
          //).ref,
          onClick: function onClick(e) {
            e.stopPropagation();
            e.nativeEvent.stopImmediatePropagation();
          },
          className: baseClassName + '__component__input',
          id: option.value,
          type: 'number',
          value: isSigned ? values[type][option.value][0] : values[type][option.value],
          onChange: function onChange(v) {
            setFieldValue(type, (0, _extends6.default)({}, values[type], (0, _defineProperty3.default)({}, option.value, isSigned ? [v.target.value, values[type][option.value][1]] : v.target.value)));
          }
        })
      );
    };
    return _react2.default.createElement(
      'div',
      { className: baseClassName + '__socket ' + baseClassName + '__select__socket' },
      _react2.default.createElement(
        'div',
        { className: baseClassName + '__label ' + baseClassName + '__select__label' },
        (0, _helperFunctions.capitalizeEveryWord)(label)
      ),
      _react2.default.createElement(
        _SelectMany2.default,
        {
          currentOptions: currentOptions,
          options: options,
          renderTrigger: renderTrigger,
          onChange: function onChange(value) {
            console.log('onChange value', value);
            console.log('values[type]', values[type]);
            setFieldValue(type, value.reduce(function (acc, v) {
              if ((0, _keys2.default)(values[type]).length === 0) {
                acc[v.value] = 100;
              } else if (values[type][v.value]) {
                acc[v.value] = values[type][v.value];
              } else {
                acc[v.value] = 0;
              }
              return acc;
            }, {}));
            console.log((0, _keys2.default)(values[type]));
            //currentOptionsWithInputRefs
          },
          transitionType: ['dropdown', 'fade'],
          pivotFrom: 'DOWNRIGHT',
          renderCurrentOption: function renderCurrentOption(option) {
            return _react2.default.createElement(
              'div',
              { className: baseClassName + '__component' },
              _react2.default.createElement(
                'div',
                {
                  className: baseClassName + '__component__label'
                },
                option.label
              ),
              renderCurrentOptionInputs({
                option: option,
                isSigned: Array.isArray(values[type][option.value])
              })
            );
          }
        },
        function (_ref4) {
          var getChildProps = _ref4.getChildProps,
              getChildrenProps = _ref4.getChildrenProps,
              currentOptions = _ref4.currentOptions;
          return _react2.default.createElement(
            'div',
            (0, _extends6.default)({}, getChildrenProps({ style: { width: '25.5rem' } })),
            options.map(function (option) {
              return _react2.default.createElement(
                _Button2.default,
                (0, _extends6.default)({
                  colors: 'neutral',
                  isOn: currentOptions.map(function (currentOption) {
                    return currentOption.value;
                  }).includes(option.value)
                }, getChildProps({
                  option: { value: option.value, label: option.label }
                }), {
                  key: option.value
                }),
                option.label
              );
            })
          );
        }
      )
    );
  };

  var renderSelectManyWithCompositionSocket = function renderSelectManyWithCompositionSocket(_ref5) {
    var type = _ref5.type,
        label = _ref5.label,
        options = _ref5.options,
        currentOptions = _ref5.currentOptions,
        renderTrigger = _ref5.renderTrigger;

    return _react2.default.createElement(
      'div',
      { className: baseClassName + '__socket ' + baseClassName + '__select__socket' },
      _react2.default.createElement(
        'div',
        { className: baseClassName + '__label ' + baseClassName + '__select__label' },
        (0, _helperFunctions.capitalizeEveryWord)(label)
      ),
      _react2.default.createElement(
        _SelectMany2.default,
        {
          currentOptions: values[type] ? (0, _keys2.default)(values[type]).map(function (v) {
            return {
              value: v,
              label: options.find(function (o) {
                return o.value === v;
              }) ? options.find(function (o) {
                return o.value === v;
              }).label : 'label not found'
            };
          }) : [],
          options: options,
          renderTrigger: renderTrigger,
          onChange: function onChange(value) {
            setFieldValue(type, value.reduce(function (acc, v) {
              acc[v.value] = 0;
              return acc;
            }, {}));
          },
          transitionType: ['dropdown', 'fade'],
          pivotFrom: 'DOWNRIGHT'
        },
        function (_ref6) {
          var getChildProps = _ref6.getChildProps,
              getChildrenProps = _ref6.getChildrenProps,
              currentOptions = _ref6.currentOptions;
          return _react2.default.createElement(
            'div',
            (0, _extends6.default)({}, getChildrenProps({ style: { width: '25.5rem' } })),
            options.map(function (option) {
              return _react2.default.createElement(
                _Button2.default,
                (0, _extends6.default)({}, getChildProps({
                  option: { value: option.value, label: option.label }
                }), {
                  key: option.value
                }),
                option.label
              );
            })
          );
        }
      ),
      values[type] && (0, _keys2.default)(values[type]).map(function (component) {
        return _react2.default.createElement(
          'div',
          { key: component, className: baseClassName + '__component' },
          _react2.default.createElement(
            'div',
            { className: baseClassName + '__component__label' },
            options.find(function (o) {
              return o.value === component;
            }) ? options.find(function (o) {
              return o.value === component;
            }).label : 'label not found'
          ),
          _react2.default.createElement('input', {
            className: baseClassName + '__component__input',
            id: component,
            type: 'number',
            value: values[type][component],
            onChange: function onChange(v) {
              setFieldValue(type, (0, _extends6.default)({}, values[type], (0, _defineProperty3.default)({}, component, v.target.value)));
            }
          })
        );
      })
    );
  };

  var renderSelectManySocket = function renderSelectManySocket(_ref7) {
    var type = _ref7.type,
        label = _ref7.label,
        options = _ref7.options,
        currentOptions = _ref7.currentOptions,
        renderTrigger = _ref7.renderTrigger;

    return _react2.default.createElement(
      'div',
      { className: baseClassName + '__socket ' + baseClassName + '__select__socket' },
      _react2.default.createElement(
        'div',
        { className: baseClassName + '__label ' + baseClassName + '__select__label' },
        (0, _helperFunctions.capitalizeEveryWord)(label)
      ),
      _react2.default.createElement(
        _SelectMany2.default,
        {
          currentOptions: values[type],
          options: options,
          renderTrigger: renderTrigger,
          onChange: function onChange(value) {
            setFieldValue(type, value);
          },
          transitionType: ['dropdown', 'fade'],
          pivotFrom: 'DOWNRIGHT'
        },
        function (_ref8) {
          var getChildProps = _ref8.getChildProps,
              getChildrenProps = _ref8.getChildrenProps;
          return _react2.default.createElement(
            'div',
            (0, _extends6.default)({}, getChildrenProps({
              className: baseClassName + '__dropdown',
              style: { width: '25.5rem' }
            })),
            options.map(function (option) {
              return _react2.default.createElement(
                _Button2.default,
                (0, _extends6.default)({}, getChildProps({
                  option: { value: option.value, label: option.label }
                }), {
                  key: option.value
                }),
                option.label
              );
            })
          );
        }
      )
    );
  };

  var renderSelectOneSocket = function renderSelectOneSocket(_ref9) {
    var type = _ref9.type,
        label = _ref9.label,
        options = _ref9.options;

    return _react2.default.createElement(
      'div',
      { className: baseClassName + '__socket ' + baseClassName + '__select__socket' },
      _react2.default.createElement(
        'div',
        { className: baseClassName + '__label ' + baseClassName + '__select__label' },
        (0, _helperFunctions.capitalizeEveryWord)(label)
      ),
      _react2.default.createElement(
        _SelectOne2.default,
        {
          renderTrigger: function renderTrigger(_ref10) {
            var isOn = _ref10.isOn,
                currentOption = _ref10.currentOption,
                getTriggerProps = _ref10.getTriggerProps;
            return _react2.default.createElement(
              _Button2.default,
              (0, _extends6.default)({
                type: 'caretdown',
                isOn: isOn
              }, getTriggerProps({
                className: 'selectone__trigger',
                style: { border: '1px solid #ccc' }
              }), {
                colors: _.buttonStyles.monochrome
              }),
              currentOption ? currentOption.label : ''
            );
          },
          options: options,
          currentOption: values[type],
          onChange: function onChange(value) {
            setFieldValue(type, value);
          },
          transitionType: ['dropdown', 'fade'],
          pivotFrom: 'DOWNRIGHT'
        },
        function (_ref11) {
          var getChildProps = _ref11.getChildProps,
              getChildrenProps = _ref11.getChildrenProps,
              currentOption = _ref11.currentOption,
              toggleIsOn = _ref11.toggleIsOn;
          return _react2.default.createElement(
            'div',
            (0, _extends6.default)({}, getChildrenProps({ style: { width: '25.5rem' } })),
            options.map(function (option) {
              return _react2.default.createElement(
                _Button2.default,
                (0, _extends6.default)({}, getChildProps({
                  option: { value: option.value, label: option.label },
                  onClick: toggleIsOn
                }), {
                  isOn: currentOption.value === option.value,
                  key: option.value
                }),
                option.label
              );
            })
          );
        }
      )
    );
  };

  var renderSubmitButton = function renderSubmitButton() {
    var _ref12 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    var label = _ref12.label,
        props = (0, _objectWithoutProperties3.default)(_ref12, ['label']);
    return _react2.default.createElement(
      _Button2.default,
      (0, _extends6.default)({
        invert: true,
        colors: 'surfing',
        onClick: handleSubmit,
        dataTestId: 'submit',
        disabled: isSubmitting,
        style: { width: '24rem', borderRadius: '.25rem' }
      }, props),
      label
    );
  };

  var renderTextInputSocket = function renderTextInputSocket(_ref13) {
    var type = _ref13.type,
        label = _ref13.label,
        sublabel = _ref13.sublabel,
        _ref13$options = _ref13.options,
        options = _ref13$options === undefined ? { required: true, autoFocus: false, autoComplete: '' } : _ref13$options,
        props = (0, _objectWithoutProperties3.default)(_ref13, ['type', 'label', 'sublabel', 'options']);

    return _react2.default.createElement(
      'div',
      (0, _extends6.default)({ className: baseClassName + '__socket' }, props),
      _react2.default.createElement('input', {
        id: type,
        className: baseClassName + '__socket__input ' + baseClassName + '__socket__input__' + type.toLowerCase(),
        type: 'text',
        required: options.required ? options.required : true,
        autoFocus: options.autoFocus ? options.autoFocus : false,
        value: values[type],
        autoComplete: options.autoComplete ? options.autoComplete : '',
        onChange: handleChange,
        onBlur: function onBlur() {
          return setFieldTouched(type);
        }
      }),
      _react2.default.createElement(
        'div',
        { className: baseClassName + '__label ' + baseClassName + '__socket__label' },
        (0, _helperFunctions.capitalizeEveryWord)(label)
      ),
      _react2.default.createElement('div', { className: baseClassName + '__socket__bar' }),
      sublabel && _react2.default.createElement(
        'div',
        { className: baseClassName + '__socket__sublabel' },
        sublabel
      ),
      renderError(type)
    );
  };

  var renderGroup = function renderGroup(_ref14) {
    var label = _ref14.label,
        renderChildren = _ref14.renderChildren;
    return _react2.default.createElement(
      'div',
      { className: baseClassName + '__group' },
      _react2.default.createElement(
        'div',
        { className: baseClassName + '__label ' + baseClassName + '__group__label' },
        label
      ),
      _react2.default.createElement(
        'div',
        { className: baseClassName + '__children ' + baseClassName + '__group__children' },
        renderChildren()
      )
    );
  };

  var renderCheckboxSocket = function renderCheckboxSocket(_ref15) {
    var label = _ref15.label,
        type = _ref15.type;
    return _react2.default.createElement(
      'div',
      { className: baseClassName + '__checkbox' },
      _react2.default.createElement(
        'div',
        { className: baseClassName + '__label ' + baseClassName + '__checkbox__label' },
        label
      ),
      _react2.default.createElement('input', {
        id: type,
        className: baseClassName + '__checkbox__input',
        type: 'checkbox',
        checked: values[type],
        onChange: handleChange
      })
    );
  };

  return _react2.default.createElement(
    'form',
    {
      onSubmit: handleSubmit,
      className: className ? className : 'form',
      style: style
    },
    children({
      renderTextInputSocket: renderTextInputSocket,
      renderTextareaInputSocket: renderTextareaInputSocket,
      renderSelectManyWithCompositionSocket: renderSelectManyWithCompositionSocket,
      renderSelectManyWithAdvancedCompositionSocket: renderSelectManyWithAdvancedCompositionSocket,
      renderSelectOneSocket: renderSelectOneSocket,
      renderSelectManySocket: renderSelectManySocket,
      renderCheckboxSocket: renderCheckboxSocket,
      renderGroup: renderGroup,
      renderSubmitButton: renderSubmitButton
    }),
    errors.firebase && _react2.default.createElement(
      'div',
      {
        'data-testid': 'registeraccountmodal-formerror-firebase',
        className: 'input-feedback'
      },
      'error!',
      errors.firebase
    ),
    _react2.default.createElement('input', { type: 'submit', style: { visibility: 'hidden', height: 0, width: 0 } })
  );
};

exports.Form = Form;
Form.defaultProps = {
  handleSubmit: function handleSubmit() {
    return console.log('Form: handleSubmit');
  },
  style: {}
};

var enhance = (0, _recompose.compose)();
//onlyUpdateForKeys([`values`, `touched`, `errors`, `children`])

exports.default = enhance(Form);